#!/usr/bin/perl
# $Id: smb_create.pl,v 1.6 2003/04/20 15:05:51 sveinmb Exp $
#
# Author: Odd Rune Dahle <oddrune@pvv.org>
# Date:   2003-03-26
#
# Modified by Svein Magne Bang <sveinmb@stud.ntnu.no> to read ldap-admin 
# passwd from commanline (2003-04-11)
#
# Add a user to samba, or just change the password
# if the user already exists. 
#


sub change_samba {
        $student_id = $_[0];
        $newpass = $_[1];
	$rootpass = $_[2];
	$tempfile = "/tmp/.smbhack.$$";
	umask(0177);
        open TEMP, ">$tempfile";
        print TEMP "$newpass\n$newpass";
        close TEMP;

	# try to add the user to samba
        $ret = `/usr/bin/smbpasswd -a -s $student_id < $tempfile`;

	# if it failed we change the rootpw samba uses, and try again
	# we assume the ldap admin pw has changed (or it is the first time)
	$retmsg = "";
	if($?) {
        	$ret = `/usr/bin/smbpasswd -w $rootpass`;
		if($?) {
			$retmsg .= "Failed to update ldap admin passwd in samba!";
		}        
        	$ret = `/usr/bin/smbpasswd -a -s $student_id < $tempfile`;
		if($?) {
			$retmsg .= "Failed to add user $student_id to samba!\n";
		}
        }

        unlink "$tempfile";

	if($retmsg) {
		return $retmsg;
	} else {
		return "Added user $student_id to samba\n";
	}
}

if ($#ARGV < 1) { 
	print "syntax: smb_create.pl <username> <password> <ldap-adminpw>\n";
	print "\ta user that already exist will only get the password changed\n";
	exit(1);
	}

print change_samba($ARGV[0], $ARGV[1], $ARGV[2]);
